<template>
  <VlowCanvas :library="library" :nodes="nodes"/>
</template>

<script>
import VlowCanvas from "../lib/components/VlowCanvas.vue";

import library from "../lib/libraries/std.vlowlib.json"

const nodes = [
  {
    "id"  : "1B4ACB17-B35A-4C60-B7CE-42AA9A70B0DC",
    "type": "entry",
    "x"   : -612,
    "y"   : 0,
    "node": {}
  }, {
    "id"    : "0CBDD21B-03EA-4488-98F7-11FD94C374A5",
    "type"  : "ui.Container",
    "x"     : -280,
    "y"     : 0,
    "width" : 400,
    "height": 204,
    "node"  : {
      "array": {
        "type"      : "connection",
        "connection": {
          "source": "1B4ACB17-B35A-4C60-B7CE-42AA9A70B0DC",
          "pin"   : "out"
        }
      },
      "$r0"  : {
        "type"      : "connection",
        "connection": {
          "source": "B0BE0799-454E-4498-97D1-BD88809BEC12",
          "pin"   : "out"
        }
      },
      "$r1"  : {
        "type"      : "connection",
        "connection": {
          "source": "73DB3395-5511-4735-ACFE-3B2EA6FF6D4C",
          "pin"   : "out"
        }
      }
    }
  }, {
    "id"  : "424390E7-EE8D-495F-9116-9BA8999C910B",
    "type": "updateUI",
    "x"   : 527,
    "y"   : 0,
    "node": {
      "view": {
        "type"      : "connection",
        "connection": {
          "source": "0CBDD21B-03EA-4488-98F7-11FD94C374A5",
          "pin"   : "ret"
        }
      }
    }
  }, {
    "id"  : "B0BE0799-454E-4498-97D1-BD88809BEC12",
    "type": "ui.Label",
    "x"   : -5,
    "y"   : 24,
    "node": {
      "render" : {
        "type"      : "connection",
        "connection": {
          "source": "0CBDD21B-03EA-4488-98F7-11FD94C374A5",
          "pin"   : "element"
        }
      },
      "content": {
        "type"    : "constant",
        "constant": {"value": "\"count\""}
      }
    }
  }, {
    "id"  : "7B91B632-0DDA-44B9-9622-FFC13E2ADCF0",
    "type": "observe",
    "x"   : -530,
    "y"   : 131,
    "node": {
      "object" : {
        "type"    : "constant",
        "constant": {"value": "self"}
      },
      "keypath": {
        "type"    : "constant",
        "constant": {"value": "count"}
      }
    }
  }, {
    "id"  : "D92A544A-D611-462E-B48B-F26784685CB7",
    "type": "stringInterpolation",
    "x"   : -169,
    "y"   : 130,
    "node": {
      "$0"     : {
        "type"      : "connection",
        "connection": {
          "source": "7B91B632-0DDA-44B9-9622-FFC13E2ADCF0",
          "pin"   : "ret"
        }
      },
      "pattern": {
        "type"    : "constant",
        "constant": {"value": "{0}"}
      }
    }
  }, {
    "id"  : "73DB3395-5511-4735-ACFE-3B2EA6FF6D4C",
    "type": "ui.Button",
    "x"   : -5,
    "y"   : 106,
    "node": {
      "render" : {
        "type"      : "connection",
        "connection": {
          "source": "0CBDD21B-03EA-4488-98F7-11FD94C374A5",
          "pin"   : "element"
        }
      },
      "content": {
        "type"      : "connection",
        "connection": {
          "source": "D92A544A-D611-462E-B48B-F26784685CB7",
          "pin"   : "ret"
        }
      }
    }
  }, {
    "id"  : "18B576EC-8278-42C1-AD38-45B736EE613C",
    "type": "trigger",
    "x"   : 363,
    "y"   : 130,
    "node": {
      "$0"    : {
        "type"      : "connection",
        "connection": {
          "source": "73DB3395-5511-4735-ACFE-3B2EA6FF6D4C",
          "pin"   : "click"
        }
      },
      "object": {
        "type"    : "constant",
        "constant": {"value": "self"}
      },
      "name"  : {
        "type"    : "constant",
        "constant": {"value": "IncreaseCount"}
      }
    }
  }, {
    "id"  : "188360D1-56CF-4405-B446-AC88F7DD6587",
    "type": "event",
    "x"   : -612,
    "y"   : 345,
    "node": {
      "name": {
        "type"    : "constant",
        "constant": {"value": "IncreaseCount"}
      }
    }
  }, {
    "id"  : "A5FFE8A9-E685-4F47-8201-CE530757E46C",
    "type": "get",
    "x"   : -284,
    "y"   : 345,
    "node": {
      "$0"     : {
        "type"      : "connection",
        "connection": {
          "source": "188360D1-56CF-4405-B446-AC88F7DD6587",
          "pin"   : "ret"
        }
      },
      "object" : {
        "type"    : "constant",
        "constant": {"value": "selfiisuteriwure"}
      },
      "keypath": {
        "type"    : "constant",
        "constant": {"value": "count"}
      }
    }
  }, {
    "id"  : "96FB9D5B-F484-40C2-907A-B5206E33651A",
    "type": "math",
    "x"   : -100,
    "y"   : 345,
    "node": {
      "a"         : {
        "type"      : "connection",
        "connection": {
          "source": "A5FFE8A9-E685-4F47-8201-CE530757E46C",
          "pin"   : "ret"
        }
      },
      "expression": {
        "type"    : "constant",
        "constant": {"value": "$0 + 1"}
      }
    }
  }, {
    "id"  : "C3992F6F-15A0-40DD-8F37-A44942593F8B",
    "type": "set",
    "x"   : 68,
    "y"   : 345,
    "node": {
      "object" : {
        "type"    : "constant",
        "constant": {"value": "self"}
      },
      "keypath": {
        "type"    : "constant",
        "constant": {"value": "count"}
      },
      "value"  : {
        "type"      : "connection",
        "connection": {
          "source": "96FB9D5B-F484-40C2-907A-B5206E33651A",
          "pin"   : "out"
        }
      }
    }
  }
]

export default {
  name      : "App",
  components: {
    VlowCanvas
  },
  data() {
    return {
      library,
      nodes
    }
  }
}
</script>

<style lang="scss">
body {
  background-color: #494c52;
  color: #e3e4e5;
}

:root {
  --shf-two-digits: 4.9406564584124654e-322;
  --shf-one-digit: 4.9406564584124654e-323;
  --shf-whole-number: 4.9406564584124654e-324;
}

.vlow-canvas {
  outline: 1px dotted red;
  --vlow-node-title-height: 24px;
  --vlow-node-row-height: 24px;

  --stepsize: 32;

  height: calc((var(--initial-height) / var(--stepsize)) * var(--shf-whole-number) / var(--shf-whole-number) * var(--stepsize) * 1px);
}

.vlow-node {
  .title {
    text-align: center;
    background: rgb(69 72 72);
    border: 3px solid;
    border-image: url("data:image/svg+xml,%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' viewBox='0 0 9 9' width='9' height='9'%3E%3Cpath fill='%23ccc' d='M 0, 0 m1,1v-1h1v1h1v1h-1v1h-1v-1h-1v-1z' /%3E%3Cpath fill='%23ccc' d='M 6, 0 m1,1v-1h1v1h1v1h-1v1h-1v-1h-1v-1z' /%3E%3Cpath fill='%23ccc' d='M 0, 6 m1,1v-1h1v1h1v1h-1v1h-1v-1h-1v-1z' /%3E%3Cpath fill='%23ccc' d='M 6, 6 m1,1v-1h1v1h1v1h-1v1h-1v-1h-1v-1z' /%3E%3C/svg%3E") 3 / 3px / 2px round;
  }

  &.has-left:before,
  &.has-right:after,
  &.vlow-node-decision-table:before {
    content: "";
    display: block;
    background: rgba(33, 34, 35, 0.8);
    z-index: -1;
    grid-row: 2/-1;
  }

  &.has-left:before {
    grid-column: 1/4;
  }

  &.has-right:after {
    grid-column: -4/-1;
  }

  &.vlow-node-decision-table:before {
    grid-column: 1/-1;
  }

  .content {
    /* border-bottom: 1px solid rgba(33, 34, 35, 0.8); */
    background: rgba(33, 34, 35, 0.3);
  }

  .value {
    padding-left: 5px;
  }


}
</style>
